# Source Generated with Decompyle++
# File: in.pyc (Python 1.5)

'''tools for BuildApplet and BuildApplication'''
import sys
import os
import string
import imp
import marshal
import macfs
import Res
import MACFS
import MacOS
import macostools
import EasyDialogs
BuildError = 'BuildError'
DEBUG = 1
MAGIC = imp.get_magic()
TEMPLATE = 'PythonInterpreter'
RESTYPE = 'PYC '
RESNAME = '__main__'
OWNERNAME = 'owner resource'
DEFAULT_APPLET_CREATOR = 'Pyta'
READ = 1
WRITE = 2

def findtemplate():
    '''Locate the applet template along sys.path'''
    for p in sys.path:
        template = os.path.join(p, TEMPLATE)
        
        try:
            (template, d1, d2) = macfs.ResolveAliasFile(template)
        except (macfs.error, ValueError):
            0
            0
            sys.path
            continue
        except:
            0

    else:
        raise BuildError, 'Template %s not found on sys.path' % `TEMPLATE`
    template = template.as_pathname()
    return template


def process(template, filename, output, copy_codefragment):
    if DEBUG:
        progress = EasyDialogs.ProgressBar('Processing %s...' % os.path.split(filename)[1], 120)
        progress.label('Compiling...')
    else:
        progress = None
    fp = open(filename)
    text = fp.read()
    fp.close()
    
    try:
        code = compile(text, filename, 'exec')
    except (SyntaxError, EOFError):
        raise BuildError, 'Syntax error in script %s' % `filename`

    if string.lower(filename[-3:]) == '.py':
        destname = filename[:-3]
        rsrcname = destname + '.rsrc'
    else:
        destname = filename + '.applet'
        rsrcname = filename + '.rsrc'
    if output:
        destname = output
    
    
    try:
        os.remove(destname)
    except os.error:
        pass

    process_common(template, progress, code, rsrcname, destname, 0, copy_codefragment)


def update(template, filename, output):
    if DEBUG:
        progress = EasyDialogs.ProgressBar('Updating %s...' % os.path.split(filename)[1], 120)
    else:
        progress = None
    if not output:
        output = filename + ' (updated)'
    
    
    try:
        os.remove(output)
    except os.error:
        pass

    process_common(template, progress, None, filename, output, 1, 1)


def process_common(template, progress, code, rsrcname, destname, is_update, copy_codefragment):
    template_fss = macfs.FSSpec(template)
    (template_fss, d1, d2) = macfs.ResolveAliasFile(template_fss)
    dest_fss = macfs.FSSpec(destname)
    if DEBUG:
        progress.label('Copy data fork...')
        progress.set(10)
    
    if copy_codefragment:
        tmpl = open(template, 'rb')
        dest = open(destname, 'wb')
        data = tmpl.read()
        if data:
            dest.write(data)
        
        dest.close()
        tmpl.close()
        del dest
        del tmpl
    
    if DEBUG:
        progress.label('Copy resources...')
        progress.set(20)
    
    
    try:
        output = Res.FSpOpenResFile(dest_fss, WRITE)
    except MacOS.Error:
        Res.CreateResFile(destname)
        output = Res.FSpOpenResFile(dest_fss, WRITE)

    (typesfound, ownertype) = ([], None)
    
    try:
        input = Res.FSpOpenResFile(rsrcname, READ)
    except (MacOS.Error, ValueError):
        if DEBUG:
            progress.inc(50)
        
    except:
        DEBUG

    if is_update:
        skip_oldfile = [
            'cfrg']
    else:
        skip_oldfile = []
    (typesfound, ownertype) = copyres(input, output, skip_oldfile, 0, progress)
    Res.CloseResFile(input)
    skiptypes = []
    if 'vers' in typesfound:
        skiptypes.append('vers')
    
    if 'SIZE' in typesfound:
        skiptypes.append('SIZE')
    
    if 'BNDL' in typesfound:
        skiptypes = skiptypes + [
            'BNDL',
            'FREF',
            'icl4',
            'icl8',
            'ics4',
            'ics8',
            'ICN#',
            'ics#']
    
    if not copy_codefragment:
        skiptypes.append('cfrg')
    
    input = Res.FSpOpenResFile(template_fss, READ)
    (dummy, tmplowner) = copyres(input, output, skiptypes, 1, progress)
    Res.CloseResFile(input)
    Res.UseResFile(output)
    if ownertype == None:
        newres = Res.Resource('\x00')
        newres.AddResource(DEFAULT_APPLET_CREATOR, 0, 'Owner resource')
        ownertype = DEFAULT_APPLET_CREATOR
    
    if code:
        
        try:
            res = Res.Get1NamedResource(RESTYPE, RESNAME)
            res.RemoveResource()
        except Res.Error:
            pass

        if DEBUG:
            progress.label('Write PYC resource...')
            progress.set(120)
        
        data = marshal.dumps(code)
        del code
        data = MAGIC + '\x00\x00\x00\x00' + data
        id = 0
        while id < 128:
            id = Res.Unique1ID(RESTYPE)
        res = Res.Resource(data)
        res.AddResource(RESTYPE, id, RESNAME)
        attrs = res.GetResAttrs()
        attrs = attrs | 4
        res.SetResAttrs(attrs)
        res.WriteResource()
        res.ReleaseResource()
    
    Res.CloseResFile(output)
    dest_finfo = dest_fss.GetFInfo()
    dest_finfo.Creator = ownertype
    dest_finfo.Type = 'APPL'
    dest_finfo.Flags = dest_finfo.Flags | MACFS.kHasBundle
    dest_finfo.Flags = dest_finfo.Flags & ~(MACFS.kHasBeenInited)
    dest_fss.SetFInfo(dest_finfo)
    macostools.touched(dest_fss)
    if DEBUG:
        progress.label('Done.')
    


def copyres(input, output, skiptypes, skipowner, progress = None):
    ctor = None
    alltypes = []
    Res.UseResFile(input)
    ntypes = Res.Count1Types()
    progress_type_inc = 50 / ntypes
    for itype in range(1, 1 + ntypes):
        type = Res.Get1IndType(itype)
        alltypes.append(type)
        nresources = Res.Count1Resources(type)
        progress_cur_inc = progress_type_inc / nresources
        for ires in range(1, 1 + nresources):
            res = Res.Get1IndResource(type, ires)
            (id, type, name) = res.GetResInfo()
            lcname = string.lower(name)
            size = res.size
            attrs = res.GetResAttrs()
            if DEBUG and progress:
                progress.label('Copy %s %d %s' % (type, id, name))
                progress.inc(progress_cur_inc)
            
            res.LoadResource()
            res.DetachResource()
            Res.UseResFile(output)
            
            try:
                res2 = Res.Get1Resource(type, id)
            except MacOS.Error:
                res2 = None

            if res2:
                if DEBUG and progress:
                    progress.label('Overwrite %s %d %s' % (type, id, name))
                
                res2.RemoveResource()
            
            res.AddResource(type, id, name)
            res.WriteResource()
            attrs = attrs | res.GetResAttrs()
            res.SetResAttrs(attrs)
            Res.UseResFile(input)
        
    
    return (alltypes, ctor)

